SystemOrganization addCategory: #'Seaside-Cache-NG'!

WAError subclass: #WAMaximumNumberOfSessionsExceededError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMaximumNumberOfSessionsExceededError commentStamp: 'pmm 9/8/2013 17:59' prior: 0!
http://ora-00018.ora-code.com/!

WAObject subclass: #WACacheKeyEntryNG
	instanceVariableNames: 'key keyHash value next byAccessListEntry byCreationListEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byAccessListEntry
	^ byAccessListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byCreationListEntry
	^ byCreationListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
key
	^ key! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
value
	^ value! !

WAObject subclass: #WACacheListEntryNG
	instanceVariableNames: 'previous next time cacheEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:27'!
cacheEntry
	^ cacheEntry! !

!WACacheListEntryNG methodsFor: 'operations' stamp: 'pmm 9/9/2013 09:29'!
expunge
	next isNil ifFalse: [
		next previous: previous ].
	previous isNil ifFalse: [
		previous next: next ]! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
next
	^ next! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
next: aCacheListEntry
	next := aCacheListEntry! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
previous
	^ previous! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
previous: aCacheListEntry
	previous := aCacheListEntry! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:17'!
time
	^ time! !

WAObject subclass: #WACacheNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheNG commentStamp: 'pmm 9/9/2013 09:13' prior: 0!
WACacheNG is the abstract base class for session and continuation stores in Seaside. The default implementation is WAHashCacheNG.!

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:17'!
at: aKey ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:15'!
at: aKey put: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:50'!
clear
	self subclassResponsibility! !

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:19'!
keyAtValue: anObject ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'enumerating' stamp: 'pmm 8/26/2012 12:04'!
keysAndValuesDo: aTwoArgumentBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'copying' stamp: 'pmm 9/9/2013 09:12'!
postCopy
	self subclassResponsibility! !

!WACacheNG methodsFor: 'removing' stamp: 'pmm 8/26/2012 12:16'!
remove: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:49'!
store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	self subclassResponsibility! !

WACacheNG subclass: #WAHashCacheNG
	instanceVariableNames: 'keyTable valueTable size maximumSize maximumRelativeAge maximumAbsoluteAge overflowAction byAccessRoot byCreationRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAHashCacheNG commentStamp: 'pmm 9/9/2013 09:02' prior: 0!
WAHashCacheNG is a hashtable based implementation of WACacheNG.

The characteristics of WAHashCacheNG are:
- supports both absolute and relative timeouts at the same time https://www.owasp.org/index.php/Session_Management_Cheat_Sheet#Automatic_Session_Expiration
- supports a maximum size with definable overflow action (expire oldest, expire least recently used, signal exception)
- access by key is fast (O(1) average case O(n) worst case)
- access by value is fast (O(1) average case O(n) worst case)
- reaping expired sesssions is proportinal (O(n)) to the number of expired session and independent of the total number of sessions (O(1))
- creating a new session independent of the total number of sessions

Instance Variables:
	keyTable	<Matrix | SequenceableCollection>
	valueTable	<Matrix | SequenceableCollection>
	size	<Color | DateAndTime | Duration | FloatArray | Interval | Number | OBMetaNode | Point | Timespan | TraitComposition | TraitDescription | TraitTransformation | WordArray>
	maximumSize	<ProtoObject | PseudoContext>
	maximumRelativeAge	<CharacterBlock | GRVersion | Magnitude | Point | String | UUID | WAHttpVersion>
	maximumAbsoluteAge	<CharacterBlock | GRVersion | Magnitude | Point | String | UUID | WAHttpVersion>
	overflowAction	<ProtoObject | PseudoContext>
	byAccessRoot	<ProtoObject | PseudoContext>
	byCreationRoot	<ProtoObject | PseudoContext>!

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:16'!
overflowActions
	^ Array
		with: self removeRelativeOldest
		with: self removeAbsoluteOldest
		with: self signalError! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeAbsoluteOldest
	^ #removeAbsoluteOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeRelativeOldest
	^ #removeRelativeOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:01'!
signalError
	^ #signalError! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:03'!
at: aKey ifAbsent: aBlock
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 9/8/2013 18:09'!
at: aKey put: anObject
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 18:08'!
clear
	size = 0.
	keyTable atAllPut: nil.
	valueTable atAllPut: nil. 
	byAccessRoot := nil.
	byCreationRoot := nil! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 09:39'!
expunge: aListEntry
	"update list roots"
	aListEntry == byAccessRoot
		ifTrue: [ byAccessRoot := aListEntry next ].
	aListEntry == byCreationRoot
		ifTrue: [ byCreationRoot := aListEntry next ].
	"fix previous and next pointers"
	aListEntry expunge.! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:05'!
includesKey: aKey
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:05'!
keyAtValue: anObject ifAbsent: aBlock
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/8/2013 18:05'!
keysAndValuesDo: aTwoArgumentBlock
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 09:17'!
loadFactor
	^ 0.75! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 10:08'!
performOverflowAction
	overflowAction == self class signalError ifTrue: [
		WAMaximumNumberOfSessionsExceededError signal ].
	overflowAction == self class removeAbsoluteOldest ifTrue: [
		self removeCacheEntry: byCreationRoot cacheEntry ].
	overflowAction == self class removeRelativeOldest ifTrue: [
		self removeCacheEntry: byAccessRoot cacheEntry ]! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 18:13'!
remove: anObject
	| key |
	key := self keyAtValue: anObject ifAbsent: [ ^ anObject ].
	self removeKey: key! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 10:06'!
removeCacheEntry: aCacheEntry
	self removeFromKeyTable: aCacheEntry key.
	self removeFromValueTable: aCacheEntry value.
	self expunge: aCacheEntry byAccessListEntry.
	self expunge: aCacheEntry byCreationListEntry.
	
	size := size - 1! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:30'!
removeFromKeyTable: aKey
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:30'!
removeFromValueTable: aKey
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 18:11'!
removeKey: aKey
	self notYetImplemented ! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:53'!
store: anObject
	| candidateKey |
	[ 
		candidateKey := WAKeyGenerator current keyOfLength: self keySize.
		self includesKey: candidateKey ] whileTrue.
	self at: candidateKey put: anObject.
	^ candidateKey! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 10:06'!
sweep: aListRoot maximumAge: anNumberOfSeconds now: currentSeconds
	| current |
	current := aListRoot.
	current isNil whileFalse: [
		(current time + anNumberOfSeconds) > currentSeconds
			ifTrue: [
				self removeCacheEntry: current cacheEntry ]
			ifFalse: [
				"the list is ordered so we can stop scanning"
				^ self ] ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 10:02'!
sweepIncrementally
	| now |
	now := Time totalSeconds.
	
	"absolute timeout sweep"
	maximumAbsoluteAge > 0 ifTrue: [
		self sweep: byCreationRoot maximumAge: maximumAbsoluteAge now: now ].
	
	"relative timeout sweep"
	maximumRelativeAge > 0 ifTrue: [
		self sweep: byAccessRoot maximumAge: maximumRelativeAge now: now ]! !

WACacheNG subclass: #WAMutualExclusionCacheNG
	instanceVariableNames: 'mutex cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMutualExclusionCacheNG commentStamp: 'pmm 9/9/2013 09:07' prior: 0!
WAMutualExclusionCacheNG is a wrapper around a WACacheNG that wraps all messages in a mutex.

Instance Variables:
	mutex	<WAMutex>
	cache	<WACache>!

!WAMutualExclusionCacheNG class methodsFor: 'instance creation' stamp: 'pmm 8/26/2012 12:08'!
on: aCache
	^ self basicNew initializeOn: aCache; yourself! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
at: aKey ifAbsent: aBlock
	^ mutex critical: [
		cache at: aKey ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 9/8/2013 17:49'!
at: aKey put: anObject
	^ mutex critical: [
		cache at: aKey put: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:49'!
clear
	^ mutex critical: [
		cache clear ]	! !

!WAMutualExclusionCacheNG methodsFor: 'initialization' stamp: 'pmm 9/1/2012 11:07'!
initializeOn: aCache
	self initialize.
	mutex := WAMutex new.
	cache := aCache! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
keyAtValue: anObject ifAbsent: aBlock
	^ mutex critical: [
		cache keyAtValue: anObject ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/8/2013 17:48'!
keysAndValuesDo: aTwoArgumentBlock
	^ mutex critical: [
		cache keysAndValuesDo: aTwoArgumentBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 17:50'!
remove: anObject
	^ mutex critical: [
		cache remove: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:48'!
store: anObject
	^ mutex critical: [
		cache store: anObject ]	! !

WAObject subclass: #WACacheValueEntryNG
	instanceVariableNames: 'value valueHash key next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!
